//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SizeGripPanel.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSizeGripPanel *)
{
    new TSizeGripPanel(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSizeGripPanel::TSizeGripPanel(TComponent* Owner)
    : TPanel(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TSizeGripPanel::Paint(void)
{
    TPanel::Paint();
    TRect rc = GetClientRect();
    rc.Left = rc.Right  - GetSystemMetrics(SM_CXHSCROLL);
    rc.Top  = rc.Bottom - GetSystemMetrics(SM_CYVSCROLL);
    DrawFrameControl(Canvas->Handle, &(RECT(rc)), DFC_SCROLL, DFCS_SCROLLSIZEGRIP);
}

//---------------------------------------------------------------------------
void __fastcall TSizeGripPanel::Resize(void)
{
    Invalidate();
    TPanel::Resize();
}

//---------------------------------------------------------------------------
void TSizeGripPanel::OnNCHitTest(TWMNCHitTest &Message)
{
    TPanel::Dispatch(&Message);

    if(Message.Result == HTCLIENT)
    {
        TRect rc = GetClientRect();
        rc.Left = rc.Right  - GetSystemMetrics(SM_CXHSCROLL);
        rc.Top  = rc.Bottom - GetSystemMetrics(SM_CYVSCROLL);

        POINT ConvertPoint = Point(Message.XPos, Message.YPos);
        ConvertPoint = ScreenToClient(ConvertPoint);

        if(ConvertPoint.x >= rc.Left &&
           ConvertPoint.x <= rc.Right &&
           ConvertPoint.y >= rc.Top &&
           ConvertPoint.y <= rc.Bottom)
        {
            Message.Result = HTBOTTOMRIGHT;
        }
    }
}

//---------------------------------------------------------------------------
namespace Sizegrippanel
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TSizeGripPanel)};
         RegisterComponents("MyControls", classes, 0);
    }
}
//---------------------------------------------------------------------------
 